## when 1.0.0

=== DESCRIPTION ===
Type: Package
Package: when
Title: Definition of Date and Time Dimension Tables
Version: 1.0.0
Authors@R: c(
    person("Jose", "Samos", , "jsamos@ugr.es", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0002-4457-3439")),
    person("Universidad de Granada", role = "cph")
  )
Description: In Multidimensional Systems the When dimension allows us to
    express when the analysed facts have occurred. The purpose of this
    package is to provide support for implementing this dimension in the
    form of date and time tables for Relational On-Line Analytical Processing 
    star database systems.
License: MIT + file LICENSE
URL: https://josesamos.github.io/when/,
        https://github.com/josesamos/when
BugReports: https://github.com/josesamos/when/issues
Depends: R (>= 2.10)
Imports: DBI, dm, dplyr, hms, lubridate, rlang, snakecase, tibble,
        utils, xlsx
Suggests: dbplyr, DiagrammeR, DiagrammeRsvg, knitr, pander, rmarkdown,
        RSQLite, testthat (>= 3.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
Language: en-GB
LazyData: true
RoxygenNote: 7.2.3
NeedsCompilation: no
Packaged: 2024-01-08 10:18:10 UTC; joses
Author: Jose Samos [aut, cre] (<https://orcid.org/0000-0002-4457-3439>),
  Universidad de Granada [cph]
Maintainer: Jose Samos <jsamos@ugr.es>
Repository: CRAN
Date/Publication: 2024-01-09 08:40:02 UTC

## when 1.0.23

=== Makefile ===
FILES = when Makefile README when.1 web_page_template.pl

prefix=/usr
exec_prefix=$(prefix)
bindir=$(exec_prefix)/bin

MANDIR = $(prefix)/share/man/man1

# The following two lines are used only for Debian packaging:
MAINTAINER_EMAIL = debiancrowell05@lightandmatter.com
MAINTAINER_NAME = Ben Crowell
# ... This is also in debian_stuff/control
VERSION = `perl when --bare_version`
DEB_NAME = when-$(VERSION)
DEB_SCRATCH = $(DEB_NAME)
DEB_TARBALL = $(DEB_NAME).tar.gz

default:
	# No compilation is required. The file ``when'' contains the
	# Perl source code. See the README file for information on how
	# to view the documentation.

install: when.1
	perl -e 'open(F,"<when") or die "file not found"; local $$/; $$code = <F>; close F; open(F,">temp") or die "error writing"; print F "#!".`which perl`."\n$$code"; close F;'
	# ... make sure it starts with the proper #! line, regardless of whether we're on Linux, BSD, etc.
	- test -d $(DESTDIR)$(bindir) || mkdir -p $(DESTDIR)$(bindir)
	# ... if the intended directory doesn't exist, create it
	install --mode=755 temp $(DESTDIR)$(bindir)/when
	# ... 755=u:rwx,go:rx
	rm temp
	gzip -9 <when.1 >when.1.gz
	- test -d $(DESTDIR)$(MANDIR) || mkdir -p $(DESTDIR)$(MANDIR)
	install --mode=644 when.1.gz $(DESTDIR)$(MANDIR)
	rm -f when.1.gz

deinstall:
	rm -f $(DESTDIR)$(bindir)/when
	rm -f $(DESTDIR)$(MANDIR)/when.1.gz

dist: when.tar.gz debian
	#

when.tar.gz: $(FILES) when.1
	rm -Rf when_dist
	mkdir when_dist
	cp $(FILES) when_dist
	cp -R debian_stuff when_dist/debian_stuff
	tar -zcvf when.tar.gz when_dist
	rm -Rf when_dist

clean:
	rm -Rf when*.tar.gz
	rm -f when.1.gz
	rm -Rf $(DEB_SCRATCH) *.deb *.dsc *.asc *.changes *.diff.gz
	rm -Rf debian_stuff/*~
	rm -f *~
	rm -f when.html
	rm -f when.1

when.html: when when.1 web_page_template.pl
	perl web_page_template.pl >when.html

post: when.html when.tar.gz
	cp when.html $(HOME)/Documents/web/web_page/when
	cp when.tar.gz $(HOME)/Documents/web/web_page/when
	cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Documents/web/web_page/when
	cp when_$(VERSION)-*_all.deb $(HOME)/Documents/web/web_page/when

when.1: when
	pod2man --section=1 --center="When $(VERSION)" --release="$(VERSION)" \
	        --name=WHEN <when >when.1

debian: when.1
	# debian source package
	echo $(VERSION)
	mkdir $(DEB_SCRATCH)
	cp $(FILES) $(DEB_SCRATCH)
	tar -zcf $(DEB_TARBALL) $(DEB_SCRATCH)
	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s -c GPL -f ../$(DEB_TARBALL)
	cp debian_stuff/* $(DEB_SCRATCH)/debian
	rm $(DEB_SCRATCH)/debian/*.{ex,EX} $(DEB_SCRATCH)/debian/README.Debian
	cd $(DEB_SCRATCH) && dpkg-buildpackage -rfakeroot
	rm -Rf $(DEB_SCRATCH)
	rm -Rf when_$(VERSION)
	mkdir when_$(VERSION)
	cp when_$(VERSION).orig.tar.gz when_$(VERSION)
	cp when_$(VERSION)-*.diff.gz when_$(VERSION)
	cp when_$(VERSION)-*.dsc when_$(VERSION)
	tar -zcf when_$(VERSION)-debian-source.tar.gz when_$(VERSION)
	rm -Rf when_$(VERSION)

test:
	when --language="en" --test_expression="2004 dec 25,1,m=dec & d=25,should match"
	when --language="en" --test_expression="2004 dec 26,0,m=dec & d=25,should not match"
	when --language="en" --test_expression="2004 jan  1,1,d=1 | d=15,test | operator"
	when --language="en" --test_expression="2004 jan 15,1,d=1 | d=15,test | operator"
	when --language="en" --test_expression="2004 jan 10,0,d=1 | d=15,test | operator"
	when --language="en" --test_expression="2004 jan  1,1,m=jan & (d=1 | d=15),test parentheses"
	when --language="en" --test_expression="2004 jan 15,1,m=jan & (d=1 | d=15),test parentheses"
	when --language="en" --test_expression="2004 feb 15,0,m=jan & (d=1 | d=15),test parentheses"
	when --language="en" --test_expression="2004 jan 10,0,m=jan & (d=1 | d=15),test parentheses"
	when --language="en" --test_expression="2004 jan 10,e,((d=1 | d=15)),nested parens should cause error"
	when --language="en" --test_expression="2004 jan 10,0,(d=1 | d=15),single parens should not cause error"
	when --language="en" --test_expression="2004 jan  1,1,(d=1 | d=15),single parens should not cause error"
	when --language="en" --test_expression="2004 jan 15,1,(d=1 | d=15),single parens should not cause error"
	when --language="en" --test_expression="2004 dec 25,1,y=2004,test year"
	when --language="en" --test_expression="2004 dec 25,1,m=dec,test month"
	when --language="en" --test_expression="2004 dec 25,1,m=12,test month, numerical"
	when --language="en" --test_expression="2004 dec 25,1,d=25,test day"
	when --language="en" --test_expression="2004 dec 25,1,w=sat,test day of week"
	when --language="en" --test_expression="2004 dec 25,0,w=wed,test day of week"
	when --language="en" --test_expression="2004 dec 25,0,!m=dec,test ! operator"
	when --language="en" --test_expression="2004 jan 25,1,!m=dec,test ! operator"
	when --language="en" --test_expression="2004 dec 25,1,!!m=dec,double negative, !!"
	when --language="en" --test_expression="2004 dec 25,0,!(m=dec & d=25),test !(...)"
	when --language="en" --test_expression="2004 jan 25,1,!(m=dec & d=25),test !(...)"
	when --language="en" --test_expression="2005 jan 15,1,j=53386,test j variable"
	when --language="en" --test_expression="2005 jan 25,1,!(j%14),test % operator"
	when --language="en" --test_expression="2005 jan 26,1,j%14,test % operator"
	when --language="en" --test_expression="2005 jan 26,1,!(j%14-1),test - operator"
	when --language="en" --test_expression="2005 jan 27,0,!(j%14-1),test - operator"

## when 1.1.0

=== Makefile ===
--- 
+++ 
@@ -1,3 +1,11 @@
+# making a new version:
+#    change version number near top of program
+#    make install (so make test will run the right version)
+#    make test
+#    make debian
+#        ... pwd isn't my normal gpg pwd, it's a different one
+#    make post
+
 FILES = when Makefile README when.1 web_page_template.pl
 
 prefix=/usr
@@ -8,6 +16,7 @@
 
 # The following two lines are used only for Debian packaging:
 MAINTAINER_EMAIL = debiancrowell05@lightandmatter.com
+#                       ... can't change this, or it breaks the script
 MAINTAINER_NAME = Ben Crowell
 # ... This is also in debian_stuff/control
 VERSION = `perl when --bare_version`
@@ -76,7 +85,7 @@
 	mkdir $(DEB_SCRATCH)
 	cp $(FILES) $(DEB_SCRATCH)
 	tar -zcf $(DEB_TARBALL) $(DEB_SCRATCH)
-	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s -c GPL -f ../$(DEB_TARBALL)
+	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s -copyright GPL -f ../$(DEB_TARBALL)
 	cp debian_stuff/* $(DEB_SCRATCH)/debian
 	rm $(DEB_SCRATCH)/debian/*.{ex,EX} $(DEB_SCRATCH)/debian/README.Debian
 	cd $(DEB_SCRATCH) && dpkg-buildpackage -rfakeroot
@@ -99,7 +108,7 @@
 	when --language="en" --test_expression="2004 jan 15,1,m=jan & (d=1 | d=15),test parentheses"
 	when --language="en" --test_expression="2004 feb 15,0,m=jan & (d=1 | d=15),test parentheses"
 	when --language="en" --test_expression="2004 jan 10,0,m=jan & (d=1 | d=15),test parentheses"
-	when --language="en" --test_expression="2004 jan 10,e,((d=1 | d=15)),nested parens should cause error"
+	when --language="en" --test_expression="2004 jan 10,0,((d=1 | d=15)),nested parens should be ok"
 	when --language="en" --test_expression="2004 jan 10,0,(d=1 | d=15),single parens should not cause error"
 	when --language="en" --test_expression="2004 jan  1,1,(d=1 | d=15),single parens should not cause error"
 	when --language="en" --test_expression="2004 jan 15,1,(d=1 | d=15),single parens should not cause error"

## when 1.1.12

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,14 @@
 # making a new version:
 #    change version number near top of program
+#    change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source
+#    cd /home/bcrowell/Documents/web/source && gmake //// make
 #    make install (so make test will run the right version)
 #    make test
-#    make debian
-#        ... pwd isn't my normal gpg pwd, it's a different one
+#    make debian (see password file for password)
 #    make post
+# Update it on freshmeat.
 
-FILES = when Makefile README when.1 web_page_template.pl
+FILES = when Makefile README when.1
 
 prefix=/usr
 exec_prefix=$(prefix)
@@ -63,17 +65,13 @@
 	rm -Rf $(DEB_SCRATCH) *.deb *.dsc *.asc *.changes *.diff.gz
 	rm -Rf debian_stuff/*~
 	rm -f *~
-	rm -f when.html
 	rm -f when.1
 
-when.html: when when.1 web_page_template.pl
-	perl web_page_template.pl >when.html
-
-post: when.html when.tar.gz
-	cp when.html $(HOME)/Documents/web/web_page/when
-	cp when.tar.gz $(HOME)/Documents/web/web_page/when
-	cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Documents/web/web_page/when
-	cp when_$(VERSION)-*_all.deb $(HOME)/Documents/web/web_page/when
+post: when.tar.gz when when.1
+	cp when.tar.gz $(HOME)/Lightandmatter/when
+	cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Lightandmatter/when
+	cp when_$(VERSION)-*_all.deb $(HOME)/Lightandmatter/when
+	make_plain_text_manpage.pl >$(HOME)/Documents/web/source/when/manpage.txt
 
 when.1: when
 	pod2man --section=1 --center="When $(VERSION)" --release="$(VERSION)" \
@@ -87,7 +85,7 @@
 	tar -zcf $(DEB_TARBALL) $(DEB_SCRATCH)
 	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s -copyright GPL -f ../$(DEB_TARBALL)
 	cp debian_stuff/* $(DEB_SCRATCH)/debian
-	rm $(DEB_SCRATCH)/debian/*.{ex,EX} $(DEB_SCRATCH)/debian/README.Debian
+	cd $(DEB_SCRATCH)/debian && ls && rm *.ex *.EX README.Debian
 	cd $(DEB_SCRATCH) && dpkg-buildpackage -rfakeroot
 	rm -Rf $(DEB_SCRATCH)
 	rm -Rf when_$(VERSION)
@@ -99,6 +97,7 @@
 	rm -Rf when_$(VERSION)
 
 test:
+	when --test_accent_filtering
 	when --language="en" --test_expression="2004 dec 25,1,m=dec & d=25,should match"
 	when --language="en" --test_expression="2004 dec 26,0,m=dec & d=25,should not match"
 	when --language="en" --test_expression="2004 jan  1,1,d=1 | d=15,test | operator"
@@ -128,3 +127,5 @@
 	when --language="en" --test_expression="2005 jan 26,1,j%14,test % operator"
 	when --language="en" --test_expression="2005 jan 26,1,!(j%14-1),test - operator"
 	when --language="en" --test_expression="2005 jan 27,0,!(j%14-1),test - operator"
+	when --language="en" --test_expression="2007 apr 8,1,e=0,test e (Easter) variable"
+	when --language="en" --orthodox_easter --test_expression="2008 apr 27,1,e=0,test e (Easter) variable for Orthodox calendar"

## when 1.1.23

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,18 @@
 # making a new version:
 #    change version number near top of program
 #    change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source
-#    cd /home/bcrowell/Documents/web/source && gmake //// make
 #    make install (so make test will run the right version)
 #    make test
 #    make debian (see password file for password)
 #    make post
+#    touch /home/bcrowell/Documents/web/source/when/when.source
+#    cd /home/bcrowell/Documents/web/source && make
 # Update it on freshmeat.
+# Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
+# the previous version of manpage.txt rather than reading it in afresh. To work around this,
+# need to rename it to something other than manpage.txt, alter the when.source file to refer
+# to the new name, run M4.
+# Formatting of holidays section of manpage is also messed up. Fixed by hand in html version.
 
 FILES = when Makefile README when.1
 
@@ -36,12 +42,12 @@
 	# ... make sure it starts with the proper #! line, regardless of whether we're on Linux, BSD, etc.
 	- test -d $(DESTDIR)$(bindir) || mkdir -p $(DESTDIR)$(bindir)
 	# ... if the intended directory doesn't exist, create it
-	install --mode=755 temp $(DESTDIR)$(bindir)/when
+	install -m 755 temp $(DESTDIR)$(bindir)/when
 	# ... 755=u:rwx,go:rx
 	rm temp
 	gzip -9 <when.1 >when.1.gz
 	- test -d $(DESTDIR)$(MANDIR) || mkdir -p $(DESTDIR)$(MANDIR)
-	install --mode=644 when.1.gz $(DESTDIR)$(MANDIR)
+	install -m 644 when.1.gz $(DESTDIR)$(MANDIR)
 	rm -f when.1.gz
 
 deinstall:
@@ -129,3 +135,9 @@
 	when --language="en" --test_expression="2005 jan 27,0,!(j%14-1),test - operator"
 	when --language="en" --test_expression="2007 apr 8,1,e=0,test e (Easter) variable"
 	when --language="en" --orthodox_easter --test_expression="2008 apr 27,1,e=0,test e (Easter) variable for Orthodox calendar"
+	when --language="en" --test_expression="2010 jan 1,1,z=1,day of year variable"
+	when --language="en" --test_expression="2009 nov 10,1,z=314,day of year variable"
+	when --language="en" --test_expression="2010 jul 4,1,c=0-1,c variable, for a weekend"
+	when --language="en" --test_expression="2010 jul 5,1,c=4,c variable, for a Monday"
+	when --language="en" --test_expression="2015 jul 3,1,c=4,c variable, for a Friday"
+	when --language="en" --test_expression="2012 jul 4,1,c=0-1,c variable, for a Tu-Th weekday"

=== debian/changelog ===
when (1.1.23-1) unstable; urgency=low

  * New upstream release.
  * Drop fix_517481_typo_in_localization.patch as it was applied
    upstream.
  * Refresh debian/copyright.
  * debian/control: Drop use of ${shlibs:Depends} in Depends field.

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 14 Dec 2010 08:10:12 +0100

when (1.1.22-1) unstable; urgency=low

  * New upstream release. 
  * Refresh fix_517481_typo_in_localization.patch patch.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 04 Nov 2010 09:46:22 +0100

when (1.1.21-1) unstable; urgency=low

  * New maintainer (Closes: #599895).
    - Thanks to Marcela Tiznado (mlt) for the work done so far.
  * New upstream release (Closes: #583646).
    - Adds option to not display e.g. periodic items (Closes: #439115). 
  * Bump compat level to 7. Simplify debian/rules to tiny format.
  * Convert to '3.0 (quilt)' source package format.
  * debian/control:
    - Architecture: all as package contains only architecture-independent
      files (Closes: #451606).
    - Add Homepage field to source package stanza. 
    - Correct long description of package (Closes: #503271).
    - Add ${perl:Depends} substitution variable for dh_perl in Depends field.
    - Bump versioned dependency on debhelper to debhelper (>= 7.0.50) for
      override targets.
    - Add Vcs-Browser and Vcs-Git fields to the collab-maint repository.
  * debian/rules: override target for dh_auto_test to no run the tests. 
  * Don't install README anymore. 
  * Add fix_517481_typo_in_localization.patch to fix a typo in localization
    for spanish translations. Thanks to Mauro Lizaur <mauro@cacavoladora.org>
    for reporting (Closes: #517481).
  * Bump Standards-Version to 3.9.1. 
  * Add debian/watch only explaining in comments that new upstream version
    currently cannot be monitored. 
  * debian/copyright:
    - Update debian/copyright to revision 135 of format-specification in
      DEP5 for machine readable copyright file.
    - Update copyright years and add alternate licensing to
      Artistic license.
    - Explicit point to the GPL-1 text in common-licenses as by Debian
      Policy 3.9.1.
    - Refer to Debian systems in general.

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 12 Oct 2010 09:28:12 +0200

when (1.1.12-1) unstable; urgency=low

  * New release
  
 -- Marcela Tiznado <mlt@debian.org>  Mon, 26 May 2008 22:51:36 -0300

when (1.1.0-1) unstable; urgency=low

  * Initial release (Closes: #428420)

 -- Marcela Tiznado <mlt@debian.org>  Mon, 11 Jun 2007 15:27:58 +0000

## when 1.1.28

=== debian/changelog ===
when (1.1.28-1) unstable; urgency=low

  * New upstream release.

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 15 Mar 2011 09:41:13 +0100

when (1.1.27-1) unstable; urgency=low

  * New upstream release. 

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 24 Feb 2011 08:34:21 +0100

when (1.1.26-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Update copyright years.

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 03 Feb 2011 15:31:52 +0100

when (1.1.24-1) unstable; urgency=low

  * New upstream release.
  * debian/copyright: Refresh copyright years for debian/* packaging.

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 15 Jan 2011 12:20:35 +0100

=== debian/control ===
Source: when
Section: misc
Priority: extra
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper (>= 7.0.50)
Build-Depends-Indep: perl
Standards-Version: 3.9.1
Homepage: http://www.lightandmatter.com/when/when.html
Vcs-Browser: http://git.debian.org/?p=collab-maint/when.git
Vcs-Git: git://git.debian.org/git/collab-maint/when.git

Package: when
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Description: tiny personal calendar
 Minimalistic personal calendar. It runs from the command
 line, and it uses a plain text file format, which you can edit
 using your favorite editor.

## when 1.1.29

=== debian/changelog ===
when (1.1.29-1) unstable; urgency=low

  * Imported Upstream version 1.1.29
  * Add debian/NEWS file documenting new prefilter function.
    New upstream version has the ability of spliting the calendar file into
    smaller calendars. (Closes: #621896)
  * Add m4 to Recommends
  * Bump Debhelper compat level to 8.
    Adjust Build-Depends on debhelper to (>= 8)
  * Bump Standards-Version to 3.9.2

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 22 Dec 2011 10:37:06 +0100

=== debian/control ===
Source: when
Section: misc
Priority: extra
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper (>= 8)
Build-Depends-Indep: perl
Standards-Version: 3.9.2
Homepage: http://www.lightandmatter.com/when/when.html
Vcs-Browser: http://git.debian.org/?p=collab-maint/when.git
Vcs-Git: git://git.debian.org/git/collab-maint/when.git

Package: when
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: m4
Description: tiny personal calendar
 Minimalistic personal calendar. It runs from the command
 line, and it uses a plain text file format, which you can edit
 using your favorite editor.

## when 1.1.31

=== Makefile ===
--- 
+++ 
@@ -7,12 +7,13 @@
 #    make post
 #    touch /home/bcrowell/Documents/web/source/when/when.source
 #    cd /home/bcrowell/Documents/web/source && make
-# Update it on freshmeat.
+# Update it on freecode.com.
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
 # the previous version of manpage.txt rather than reading it in afresh. To work around this,
 # need to rename it to something other than manpage.txt, alter the when.source file to refer
 # to the new name, run M4.
 # Formatting of holidays section of manpage is also messed up. Fixed by hand in html version.
+# M4 tries to carry out the stuff about M4 in the manpage, so fix that by hand.
 
 FILES = when Makefile README when.1
 
@@ -97,7 +98,7 @@
 	rm -Rf when_$(VERSION)
 	mkdir when_$(VERSION)
 	cp when_$(VERSION).orig.tar.gz when_$(VERSION)
-	cp when_$(VERSION)-*.diff.gz when_$(VERSION)
+	-cp when_$(VERSION)-*.diff.gz when_$(VERSION)
 	cp when_$(VERSION)-*.dsc when_$(VERSION)
 	tar -zcf when_$(VERSION)-debian-source.tar.gz when_$(VERSION)
 	rm -Rf when_$(VERSION)
@@ -141,3 +142,6 @@
 	when --language="en" --test_expression="2010 jul 5,1,c=4,c variable, for a Monday"
 	when --language="en" --test_expression="2015 jul 3,1,c=4,c variable, for a Friday"
 	when --language="en" --test_expression="2012 jul 4,1,c=0-1,c variable, for a Tu-Th weekday"
+	when --language="en" --test_expression="2011 mar 11,1,w=f,unambiguous single-letter literal for weekday"
+	when --language="en" --test_expression="2011 mar 10,e,w=t,ambiguous single-letter literal for weekday"
+	when --language="en" --test_expression="2011 mar 10,1,m%6=3,parser properly differentiates m=... (month literal expected on r.h.s.) from m%..."

=== debian/changelog ===
when (1.1.31-3) unstable; urgency=low

  * Bump Standards-Version to 3.9.5
  * Add 729741-fix-french-translation-for-months-names.patch patch.
    Fix translation for month names in french.
    Thanks to nb <nb@dagami.org> for the patch (Closes: #729741)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 17 Nov 2013 21:05:54 +0100

when (1.1.31-2) unstable; urgency=low

  * Upload to unstable

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 05 May 2013 06:07:29 +0200

when (1.1.31-1) experimental; urgency=low

  * Imported Upstream version 1.1.31
  * Update copyright years for upstream files and debian/* packaging
  * Use canonical URI (anonscm.debian.org) for Vcs-* fields

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 28 Mar 2013 08:02:09 +0100

when (1.1.30-1) experimental; urgency=low

  * Imported Upstream version 1.1.30
  * Update debian/copyright information.
    Update format to copyright-format 1.0 as released together with Debian
    policy 3.9.3.
    Update copyright years for debian/* packaging.
  * Bump Standards-Version to 3.9.4

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 16 Nov 2012 19:39:21 +0100

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends: debhelper (>= 8)
 Build-Depends-Indep: perl
-Standards-Version: 3.9.2
+Standards-Version: 3.9.5
 Homepage: http://www.lightandmatter.com/when/when.html
-Vcs-Browser: http://git.debian.org/?p=collab-maint/when.git
-Vcs-Git: git://git.debian.org/git/collab-maint/when.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/when.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/when.git
 
 Package: when
 Architecture: all

## when 1.1.33

=== Makefile ===
--- 
+++ 
@@ -5,8 +5,8 @@
 #    make test
 #    make debian (see password file for password)
 #    make post
-#    touch /home/bcrowell/Documents/web/source/when/when.source
-#    cd /home/bcrowell/Documents/web/source && make
+#    Update version numbers on web page (no longer made from .source file).
+#    git: commit and push
 # Update it on freecode.com.
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
 # the previous version of manpage.txt rather than reading it in afresh. To work around this,

=== debian/changelog ===
when (1.1.33-1) unstable; urgency=medium

  * Imported Upstream version 1.1.33
  * Refresh 729741-fix-french-translation-for-months-names.patch patch
  * Update copyright years for debian/* packaging

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 22 Jul 2014 13:17:11 +0200

## when 1.1.34

=== debian/changelog ===
when (1.1.34-2) unstable; urgency=medium

  * Upload to unstable
  * Update Vcs-Browser URL to cgit web frontend

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 28 Apr 2015 17:47:03 +0200

when (1.1.34-1) experimental; urgency=medium

  * Imported Upstream version 1.1.34
  * Drop 729741-fix-french-translation-for-months-names.patch patch.
    Patch was applied upstream.
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian Policy 3.9.6

 -- Salvatore Bonaccorso <carnil@debian.org>  Tue, 03 Mar 2015 21:12:38 +0100

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends: debhelper (>= 8)
 Build-Depends-Indep: perl
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.lightandmatter.com/when/when.html
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/when.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/when.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/when.git
 
 Package: when

## when 1.1.35

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,12 @@
 # making a new version:
 #    change version number near top of program
-#    change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source
+#    [doesn't work: change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source]
 #    make install (so make test will run the right version)
 #    make test
 #    make debian (see password file for password)
 #    make post
 #    Update version numbers on web page (no longer made from .source file).
 #    git: commit and push
-# Update it on freecode.com.
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
 # the previous version of manpage.txt rather than reading it in afresh. To work around this,
 # need to rename it to something other than manpage.txt, alter the when.source file to refer

=== debian/changelog ===
when (1.1.35-1) unstable; urgency=medium

  * Imported Upstream version 1.1.35
  * Bump Debhelper compat level to 9

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 05 Sep 2015 06:09:57 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: misc
 Priority: extra
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Build-Depends: debhelper (>= 8)
+Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: perl
 Standards-Version: 3.9.6
 Homepage: http://www.lightandmatter.com/when/when.html

## when 1.1.36

=== debian/changelog ===
when (1.1.36-1) unstable; urgency=medium

  * Imported Upstream version 1.1.36
    - Removes inactive code that caused problem with Perl 5.24. Invoking
      under Perl 5.24 causes 'Invalid range "y-a" in transliteration
      operator' error as well causing FTBFS. Thanks Niko Tyni for the report.
      (Closes: #825955)
  * debian/control: Use HTTPS transport protocol for Vcs-Git URI
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian policy 3.9.8

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 02 Jun 2016 14:18:30 +0200

=== debian/control ===
--- 
+++ 
@@ -4,10 +4,10 @@
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: perl
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.lightandmatter.com/when/when.html
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/when.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/when.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/when.git
 
 Package: when
 Architecture: all

## when 1.1.37

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
 # making a new version:
 #    change version number near top of program
 #    [doesn't work: change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source]
+#    Update version numbers on web page (no longer made from .source file).
 #    make install (so make test will run the right version)
 #    make test
-#    make debian (see password file for password)
+#    make debian (see password file for password, is not one I use for anything else)
 #    make post
-#    Update version numbers on web page (no longer made from .source file).
 #    git: commit and push
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
 # the previous version of manpage.txt rather than reading it in afresh. To work around this,

=== debian/changelog ===
when (1.1.37-2) unstable; urgency=medium

  * Add basic autopkgtests running upstream testsuite against installed binary

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 25 Jun 2017 22:17:05 +0200

when (1.1.37-1) unstable; urgency=medium

  * New upstream version 1.1.37
  * debian/copyright: Use HTTPS transport protocol for Format URL
  * Update copyright years for debian/* packaging files
  * Declare compliance with Debian policy 4.0.0

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 25 Jun 2017 22:03:27 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
 Build-Depends: debhelper (>= 9)
 Build-Depends-Indep: perl
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://www.lightandmatter.com/when/when.html
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/when.git
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/when.git

=== debian/watch ===
# Currently there is no possibility to monitor new
# upstream versions of 'when' as the new upstream
# versions are not released as when-$version.tar.gz
# but only as when.tar.gz.

## when 1.1.38

=== Makefile ===
--- 
+++ 
@@ -5,6 +5,7 @@
 #    make install (so make test will run the right version)
 #    make test
 #    make debian (see password file for password, is not one I use for anything else)
+#            ...this fails as of 2018 may 6, apparently because of incompatibility between versions of gpg
 #    make post
 #    git: commit and push
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
@@ -75,9 +76,10 @@
 
 post: when.tar.gz when when.1
 	cp when.tar.gz $(HOME)/Lightandmatter/when
-	cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Lightandmatter/when
-	cp when_$(VERSION)-*_all.deb $(HOME)/Lightandmatter/when
 	make_plain_text_manpage.pl >$(HOME)/Documents/web/source/when/manpage.txt
+	# debian stuff fails as of 2018 may 6:
+	#cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Lightandmatter/when
+	#cp when_$(VERSION)-*_all.deb $(HOME)/Lightandmatter/when
 
 when.1: when
 	pod2man --section=1 --center="When $(VERSION)" --release="$(VERSION)" \
@@ -89,7 +91,7 @@
 	mkdir $(DEB_SCRATCH)
 	cp $(FILES) $(DEB_SCRATCH)
 	tar -zcf $(DEB_TARBALL) $(DEB_SCRATCH)
-	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s -copyright GPL -f ../$(DEB_TARBALL)
+	-cd $(DEB_SCRATCH) && export DEBFULLNAME='$(MAINTAINER_NAME)' && dh_make -e "$(MAINTAINER_EMAIL)" -s --copyright gpl -f ../$(DEB_TARBALL)
 	cp debian_stuff/* $(DEB_SCRATCH)/debian
 	cd $(DEB_SCRATCH)/debian && ls && rm *.ex *.EX README.Debian
 	cd $(DEB_SCRATCH) && dpkg-buildpackage -rfakeroot

=== debian/changelog ===
when (1.1.38-2) unstable; urgency=medium

  * Update .gitlab-ci.yml based on Salsa CI Team's template
  * GitLab CI/Lintian: install dpkg-dev, that ships dpkg-architecture, needed
    to run some Lintian checks
  * Replace home-made GitLab CI with the standard Salsa pipeline
  * Bump Debhelper compat level to 12
  * Declare compliance with Debian policy 4.3.0

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 28 Dec 2018 23:37:27 +0100

when (1.1.38-1) unstable; urgency=medium

  * Update Vcs-* fields for switch to salsa.debian.org
  * New upstream version 1.1.38
  * Add an initial Gitlab CI config file
  * debian/.gitlab-ci.yml: Update image used for Gitlab CI
  * Bump Debhelper compat level to 10
  * Replace priority extra with optional as the former is deprecated
  * Update copyright years for debian/* packaging files
  * Set Rules-Requires-Root to no
  * Declare compliance with Debian policy 4.2.1

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 07 Oct 2018 17:23:15 +0200

=== debian/control ===
Source: when
Section: misc
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Indep: perl
Standards-Version: 4.3.0
Homepage: http://www.lightandmatter.com/when/when.html
Vcs-Browser: https://salsa.debian.org/carnil/when
Vcs-Git: https://salsa.debian.org/carnil/when.git
Rules-Requires-Root: no

Package: when
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: m4
Description: tiny personal calendar
 Minimalistic personal calendar. It runs from the command
 line, and it uses a plain text file format, which you can edit
 using your favorite editor.

## when 1.1.42

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,5 @@
 # making a new version:
 #    change version number near top of program
-#    [doesn't work: change version number in *TWO PLACES* in /home/bcrowell/Documents/web/source/when/when.source]
 #    Update version numbers on web page (no longer made from .source file).
 #    make install (so make test will run the right version)
 #    make test
@@ -8,6 +7,9 @@
 #            ...this fails as of 2018 may 6, apparently because of incompatibility between versions of gpg
 #    make post
 #    git: commit and push
+#    git tag x.y.z && git push --tags
+#    In github, do what's described here: https://help.github.com/en/github/administering-a-repository/managing-releases-in-a-repository
+#      ... packagers for distros seem to want tags and github releases to make things easier for them
 # Updating manpage doesn't work right, for reasons I don't understand. M4 seems to remember
 # the previous version of manpage.txt rather than reading it in afresh. To work around this,
 # need to rename it to something other than manpage.txt, alter the when.source file to refer
@@ -46,7 +48,7 @@
 	install -m 755 temp $(DESTDIR)$(bindir)/when
 	# ... 755=u:rwx,go:rx
 	rm temp
-	gzip -9 <when.1 >when.1.gz
+	gzip -n9 <when.1 >when.1.gz
 	- test -d $(DESTDIR)$(MANDIR) || mkdir -p $(DESTDIR)$(MANDIR)
 	install -m 644 when.1.gz $(DESTDIR)$(MANDIR)
 	rm -f when.1.gz
@@ -76,7 +78,7 @@
 
 post: when.tar.gz when when.1
 	cp when.tar.gz $(HOME)/Lightandmatter/when
-	make_plain_text_manpage.pl >$(HOME)/Documents/web/source/when/manpage.txt
+	#make_plain_text_manpage.pl >$(HOME)/Documents/web/source/when/manpage.txt
 	# debian stuff fails as of 2018 may 6:
 	#cp when_$(VERSION)-debian-source.tar.gz $(HOME)/Lightandmatter/when
 	#cp when_$(VERSION)-*_all.deb $(HOME)/Lightandmatter/when

=== debian/changelog ===
when (1.1.42-1) unstable; urgency=medium

  * Replace home-made GitLab CI with the standard Salsa pipeline
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP
  * Add debian/watch file to track new upstream releases
  * Bump Debhelper compat level to 13
  * Add basic information for debian/upstream/metadata
  * Declare compliance with Debian policy 4.6.0
  * Update copyright years for debian/* packaging files
  * New upstream version 1.1.42

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 15 Dec 2021 10:53:55 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: misc
 Priority: optional
 Maintainer: Salvatore Bonaccorso <carnil@debian.org>
-Build-Depends: debhelper-compat (= 12)
+Build-Depends: debhelper-compat (= 13)
 Build-Depends-Indep: perl
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0
 Homepage: http://www.lightandmatter.com/when/when.html
 Vcs-Browser: https://salsa.debian.org/carnil/when
 Vcs-Git: https://salsa.debian.org/carnil/when.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_test:
	# Do not run tests for when

## when 1.1.45

=== Makefile ===
--- 
+++ 
@@ -145,6 +145,7 @@
 	when --language="en" --test_expression="2010 jul 5,1,c=4,c variable, for a Monday"
 	when --language="en" --test_expression="2015 jul 3,1,c=4,c variable, for a Friday"
 	when --language="en" --test_expression="2012 jul 4,1,c=0-1,c variable, for a Tu-Th weekday"
+	when --language="en" --test_expression="2022 aug 31,1,d=n,variable n = number of days in the month"
 	when --language="en" --test_expression="2011 mar 11,1,w=f,unambiguous single-letter literal for weekday"
 	when --language="en" --test_expression="2011 mar 10,e,w=t,ambiguous single-letter literal for weekday"
 	when --language="en" --test_expression="2011 mar 10,1,m%6=3,parser properly differentiates m=... (month literal expected on r.h.s.) from m%..."

=== debian/changelog ===
when (1.1.45-1) unstable; urgency=medium

  [ Salvatore Bonaccorso ]
  * New upstream version 1.1.45

  [ Debian Janitor ]
  * Apply multi-arch hints. + when: Add Multi-Arch: foreign.
  * Use secure URI in Homepage field.

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 09 Dec 2022 22:07:23 +0100

when (1.1.44-1) unstable; urgency=medium

  * New upstream version 1.1.44

 -- Salvatore Bonaccorso <carnil@debian.org>  Fri, 23 Sep 2022 23:05:55 +0200

when (1.1.43-1) unstable; urgency=medium

  * New upstream version 1.1.42
  * Declare compliance with Debian policy 4.6.1
  * Update copyright years for debian/* packaging files

 -- Salvatore Bonaccorso <carnil@debian.org>  Thu, 25 Aug 2022 23:30:41 +0200

=== debian/control ===
Source: when
Section: misc
Priority: optional
Maintainer: Salvatore Bonaccorso <carnil@debian.org>
Build-Depends: debhelper-compat (= 13)
Build-Depends-Indep: perl
Standards-Version: 4.6.1
Homepage: https://www.lightandmatter.com/when/when.html
Vcs-Browser: https://salsa.debian.org/carnil/when
Vcs-Git: https://salsa.debian.org/carnil/when.git
Rules-Requires-Root: no

Package: when
Architecture: all
Depends: ${misc:Depends}, ${perl:Depends}
Recommends: m4
Multi-Arch: foreign
Description: tiny personal calendar
 Minimalistic personal calendar. It runs from the command
 line, and it uses a plain text file format, which you can edit
 using your favorite editor.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
https://github.com/bcrowell/when/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
